/* ---------------------------------------------------------------------------
A. Veneziani - Programma in C++ calcolante i numeri primi da 1 a n

Scritto e compilato con Borland Turbo C++ 2006
--------------------------------------------------------------------------- */

#include "iostream.h"
#include "conio.h"

// procedura principale chiamata dal sistema operativo
int main()
{
    // dichiarazioni di variabili
	int limite, n, scan, resto;
    bool eprimo;

	// input del numero fino al quale deve essere effettuata
	// la ricerca di numeri primi
	cout << "Indica fino a quale numero devono essere trovati i primi:  ";
	cin >> limite;

	// indicazione scritta a video del risultato...
	cout << endl << "I numeri primi tra 1 e " << limite << " sono:" << endl << endl;
	// ciclo di ricerca dei numeri primi, che analizza la divisibilit
	// da 2 a (n - 1) di tutti i numeri sottoposti
	for (n = 1; n <= limite; n++)
	{
	   // ipotizza che il numero sia primo
	   eprimo = true;
	   // testa la sua divisibilit con tutti i possibili divisori,
	   // cos da verificare effettivamente la sua primalit
	   for (scan = (n - 1); scan > 1; --scan)
	   {
		   // calcolo del resto per determinare se n  divisibile per scan
		   // tramite una divisione intera
		   resto = n % scan;
		   //  divisibile per scan (un certo divisore)
		   // e quindi non  primo...
		   if (resto == 0)
		   {
			   eprimo = false;
			   // interrompe ulterori, inutili, ricerche
			   break;
		   }
	   }

	   // se n risultasse primo alla fine del procedimento
	   // viene stampato a video nella apposita lista dei primi
	   if (eprimo)  cout << n << endl;
	}

	cout << endl << "Premi un tasto per uscire del programma...";
	getch();       // blocca l'uscita dal programma

	return 0;      // rende un codice 0 indicante l'esecuzione senza errori
}
//---------------------------------------------------------------------------
